#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"


#define F_CPU 16000000UL
#define VENDOR_RQ_SET_LED    0
#define VENDOR_RQ_GET_SWITCH 1
#define VENDOR_RQ_GET_LIGHT  2
#define VENDOR_RQ_SET_HZ 3
usbMsgLen_t usbFunctionSetup(uchar data[8])
{
    usbRequest_t *rq = (void *)data;
    if(rq->bRequest == VENDOR_RQ_SET_HZ)
    {
	//OCR1A = rq->wValue.bytes[0]*65536 +rq->wIndex.bytes[1]*256 + rq->wIndex.bytes[0];
	OCR1A = rq->wValue.bytes[0]+rq->wValue.bytes[1]*256;	
	TCNT1 = 0;	
	return 1;
    }
    return 0;       	
}
ISR(TIMER1_COMPA_vect)
{	
	if(!(PORTC >> 5))
		PORTC = 0b00100100;
	else
		PORTC = 0b00000001;
}
int main()
{
   	usbInit();
    	usbDeviceDisconnect();
    	_delay_ms(300);     /* fake USB disconnect for > 250 ms */
    	usbDeviceConnect();
    	sei();              /* enable interrupts */
	DDRC = 0b00100111;
	PORTC = 0b00100100;
	TCCR1A = 0x00;
 	TCCR1B = (_BV(WGM12) | _BV(CS12));	
 	OCR1A =  62500;
	TIMSK1 = _BV(OCIE1A);
	while (1)           /* main event loop */
    	{                
       	usbPoll();
 	}
 	return 0;
}

